#include <stdio.h>
#include <bits/stdc++.h>
#include <algorithm>
#include "riders.h"
using namespace std;

#ifdef EVAL
ifstream in("input.txt");
ofstream out("output.txt");
#else
istream &in(cin);
ostream &out(cout);
#endif

int t = 0;
int N, K, S;
int tot_profit = 0;

vector<vector<int>> graph;
vector<int> payoffs;
vector<bool> visited;
vector<int> path;

void read_input() {
    in >> N >> K >> S;
    graph.resize(N);
    visited.resize(N);
    payoffs.resize(N);

    for(int i=0; i<N; i++) {
        graph[i].resize(N);
        visited[i] = false;
    }
    // source is visited
    visited[S] = true;

    int p;
    for(int i=0; i<N; i++) {
        in >> p;
        payoffs[i] = p;
    }

    int w;
    for(int i=1; i<N; i++) {
        for(int j=0; j<i; j++) {
            in >> w;
            graph[i][j] = w;
            graph[j][i] = w;
        }
    }

    return;
}


void print_input() {
    printf("N: %d, K: %d, S: %d\n", N, K, S);

    printf("-- payoffs:\n");
    for(int p : payoffs) {
        printf("%d ", p);
    }
    printf("\n");

    printf("-- graph:\n");
    for(int i=1; i<N; i++) {
        for(int j=0; j<i; j++) {
            printf("%*d ", 4, graph[i][j]);
        }
        printf("\n");
    }

    return;
}


void write_solution() {
    out << tot_profit << endl;
    out << path.size() << endl;
    for(int n: path) {
        out << n << " ";
    }
    out << endl;
    for(int k=1; k<K; k++) {
        out << 1 << endl;
        out << S << endl;
    }

    out << "***" << endl;

    return;
}


bool all_visited() {
    bool res = false;

    if(all_of(visited.begin(), visited.end(), [](bool v) { return v; })) {
        res = true;
    }

    return res;
}

int main() {
    read_input();
    print_input();

    t = 0;
    tot_profit = 0;
    path.push_back(S);

    int curn = S;
    while(!all_visited()) {
        int minw = INT_MAX;
        int newn = -1;
        for(int j=0; j<N; j++) {
            if((!visited[j]) && (graph[curn][j] <= minw)) {
                minw = graph[curn][j];
                newn = j;
            }
        }

        // we don't know were to go
        if(newn==-1) {
            break;
        }

        // book keeping
        t = t + minw;
        path.push_back(newn);

        tot_profit = tot_profit + max(0, (payoffs[newn]-t));
        visited[newn] = true;

        // update position
        curn = newn;
    }

    write_solution();

    return 0;
}
